RHEL Engineering is moving the tracking of its product development work on RHEL 6 through RHEL 9 to Red Hat Jira (issues.redhat.com). If you're a Red Hat customer, please continue to file support cases via the Red Hat customer portal. If you're not, please head to the "RHEL project" in Red Hat Jira and file new tickets here. Individual Bugzilla bugs in the statuses "NEW", "ASSIGNED", and "POST" are being migrated throughout September 2023. Bugs of Red Hat partners with an assigned Engineering Partner Manager (EPM) are migrated in late September as per pre-agreed dates. Bugs against components "kernel", "kernel-rt", and "kpatch" are only migrated if still in "NEW" or "ASSIGNED". If you cannot log in to RH Jira, please consult article #7032570. That failing, please send an e-mail to the RH Jira admins at rh-issues@redhat.com to troubleshoot your issue as a user management inquiry. The email creates a ServiceNow ticket with Red Hat. Individual Bugzilla bugs that are migrated will be moved to status "CLOSED", resolution "MIGRATED", and set with "MigratedToJIRA" in "Keywords". The link to the successor Jira issue will be found under "Links", have a little "two-footprint" icon next to it, and direct you to the "RHEL project" in Red Hat Jira (issue links are of type "https://issues.redhat.com/browse/RHEL-XXXX", where "X" is a digit). This same link will be available in a blue banner at the top of the page informing you that that bug has been migrated.
Bug 2085088 - Incomplete filtering of ciphersuites in FIPS mode
Summary: Incomplete filtering of ciphersuites in FIPS mode
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 9
Classification: Red Hat
Component: openssl
Version: 9.0
Hardware: Unspecified
OS: Unspecified
low
low
Target Milestone: rc
: ---
Assignee: Dmitry Belyavskiy
QA Contact: Hubert Kario
URL:
Whiteboard:
Depends On:
Blocks: 2091994
TreeView+ depends on / blocked
 
Reported: 2022-05-12 19:02 UTC by Hubert Kario
Modified: 2023-06-05 16:10 UTC (History)
3 users (show)

Fixed In Version: openssl-3.0.1-43.el9_0
Doc Type: No Doc Update
Doc Text:
Clone Of:
: 2091994 (view as bug list)
Environment:
Last Closed: 2023-06-05 16:10:05 UTC
Type: Bug
Target Upstream Version:
Embargoed:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Issue Tracker CRYPTO-7249 0 None None None 2022-05-17 11:49:00 UTC
Red Hat Issue Tracker RHELPLAN-121912 0 None None None 2022-05-12 19:09:42 UTC

Description Hubert Kario 2022-05-12 19:02:39 UTC
Description of problem:
When OpenSSL is working in FIPS mode, the cipher selection process (which ciphers can actually be used) is incomplete. When openssl is configured with ciphersuites like DHE-RSA-ARIA128-GCM-SHA256 it correctly aborts with a "no cipher match" error, as there are no ciphers usable for TLS 1.2.
If instead it's started with kRSA as the cipherstring, it will not abort, and it will actually attempt a connection, but the operation will fail on client side, with it sending an internal_error alert instead of ClientKeyExchange.

Version-Release number of selected component (if applicable):
openssl-3.0.1-27.el9_0.

How reproducible:
always

Steps to Reproduce:
1. openssl req -x509 -newkey rsa -keyout localhost.key -out localhost.crt -subj /CN=localhost -nodes -batch
2. openssl s_server -key localhost.key -cert localhost.crt -cipher kRSA -www &> server.log &
3. openssl s_client -tls1_2 -cipher kRSA

Actual results:
client:
C0B11677537F0000:error:1C8000A5:Provider routines:rsa_encrypt:illegal or unsupported padding mode:providers/implementations/asymciphers/rsa_enc.c:157:
C0B11677537F0000:error:0A080006:SSL routines:tls_construct_cke_rsa:EVP lib:ssl/statem/statem_clnt.c:2863:

server:
C081DE4ED37F0000:error:0A000438:SSL routines:ssl3_read_bytes:tlsv1 alert internal error:ssl/record/rec_layer_s3.c:1584:SSL alert number 80

Expected results:
the server should not start with the -cipher kRSA option, it should abort with a  
C0F1676C707F0000:error:0A0000B9:SSL routines:SSL_CTX_set_cipher_list:no cipher match:ssl/ssl_lib.c:2731:

Additional info:
CCM8 ciphersuites aren't rejected at all

Comment 1 Dmitry Belyavskiy 2022-05-18 13:59:43 UTC
kRSA shouldn't be chosen by server in FIPS mode.

Comment 9 Clemens Lang 2023-06-05 16:10:05 UTC
RHEL 9.1 contains openssl-3.0.1-43.el9_0.


Note You need to log in before you can comment on or make changes to this bug.